<template>
  <div>
    <div class="fr-p-8w">
      <div
        class="fr-grid-row"
        :class="{ 'anct-flex-column-reverse': isMobile }"
      >
        <div class="fr-col-lg-8 fr-col">
          <div>
            <p class="fr-h3">
              <strong>{{ ansmNumberString }}</strong>
            </p>

            <FrSearch id="search-service" v-model="form.searchString" />

            <div class="fr-container fr-container--fluid fr-px-0">
              <FrCardsContainer class="fr-mr-2w">
                <FrCard
                  v-for="(ansmItem, ansmItemIndex) in ansm"
                  :key="`service-card--${ansmItemIndex}`"
                  :title="ansmItem.local_authority"
                  :to="{
                    name: 'offre-accompagnement-sur-mesure-slug',
                    params: { slug: ansmItem.slug },
                    query: $route.query,
                  }"
                  enlarge-link
                  class="fr-col-lg-4"
                >
                  <template #startDetail
                    ><p v-if="ansmItem.region" class="fr-card__detail">
                      {{ ansmItem.region }}
                    </p></template
                  >

                  <template #description>
                    <p v-if="ansmItem.department" class="fr-mb-1w fr-text--sm">
                      <strong>{{ ansmItem.department }}</strong>
                    </p>

                    <ul class="fr-text--sm">
                      <li v-if="ansmItem.need_a && ansmItem.need_a[0]">
                        {{ ansmItem.need_a[0] }}
                      </li>
                      <li v-if="ansmItem.need_b && ansmItem.need_b[0]">
                        {{ ansmItem.need_b[0] }}
                      </li>
                      <li v-if="ansmItem.need_c && ansmItem.need_c[0]">
                        {{ ansmItem.need_c[0] }}
                      </li>
                      <li v-if="ansmItem.need_d && ansmItem.need_d[0]">
                        {{ ansmItem.need_d[0] }}
                      </li>
                      <li v-if="ansmItem.need_e && ansmItem.need_e[0]">
                        {{ ansmItem.need_e[0] }}
                      </li>
                    </ul>
                  </template>
                  <template #endDetail>
                    <FrTag
                      class="fr-text--xs fr-tag--icon-left"
                      :class="getTagCSSClasses(ansmItem.population)"
                      :label="getPopulationNumber(ansmItem.population)"
                    />
                  </template>
                </FrCard>
              </FrCardsContainer>
            </div>

            <FrPagination
              v-if="pagination.total > pagination.limit"
              v-model="pagination.current"
              :total="Math.ceil(pagination.total / pagination.limit)"
              class="fr-mt-4w anct-flex-center"
              @input="updatePage"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import cloneDeep from 'lodash.clonedeep';
import qs from 'qs';
import { ANSMINDEX } from '~/plugins/meilisearch';
import {
  SCALE_FILTER,
  THEME_FILTER,
  PROGRAM_OPTIONS,
} from '~/pages/services/data';
import FrSearch from '~/components/form/Search';
import FrCard from '~/components/elements/Card';
import FrCardsContainer from '~/components/elements/CardsContainer';
import FrPagination from '~/components/elements/Pagination';
import FrTag from '~/components/ui/tags/Basic';
import paginationMixin, {
  getInitialPagination,
} from '~/pages/services/paginationMixin';

const initialForm = {
  searchString: '',
  scales: [],
  themes: [],
  program: '',
  isAnsmItem: true,
  isGuide: false,
  isAvailable: false,
};

const initialPagination = getInitialPagination();

const searchAnsmItem = async (
  search,
  { index, pagination, filter, searchString },
) => {
  const { hits, nbHits } = await search.index(index).search(searchString, {
    filter,
    limit: pagination.limit,
    offset: (pagination.current - 1) * pagination.limit,
  });

  return {
    ansm: hits.map(cleanAnsmItemFormatForCard),
    total: nbHits,
  };
};

const cleanAnsmItemFormatForCard = (ansmItem) => ({
  ...ansmItem,
});

const getCompatibleFormFromQueryFilter = (queryFilter) =>
  queryFilter.reduce((acc, value) => {
    let key;
    let cleanedValue;

    if (typeof value === 'string') {
      [key] = value.split(' = ');
      [, cleanedValue] = value.split(' = ')[1].split('"');
    } else {
      key = value[0].split(' = ')[0].trim();
      cleanedValue = value.map((v) => v.split(' = ')[1].split('"')[1]);
    }

    switch (key) {
      case 'target':
        return { ...acc, scales: cleanedValue };
      case 'themes':
      case 'competence':
        return { ...acc, themes: cleanedValue };
      case 'program':
        return { ...acc, program: cleanedValue };
      case 'stage':
        return {
          ...acc,
          isAvailable: cleanedValue === 'Disponible',
        };
      default:
        return acc;
    }
  }, {});

export default {
  name: 'ANSMPage',

  components: {
    FrSearch,
    FrCard,
    FrCardsContainer,
    FrPagination,
    FrTag,
  },

  mixins: [paginationMixin(initialPagination)],

  layout: 'raw',

  async asyncData({ $search, query, $config }) {
    const parsedFilterQuery = qs.parse(query.filter);
    const filter = Object.values(parsedFilterQuery);
    const searchString = query.search || '';

    const { total, ansm } = await searchAnsmItem($search, {
      index: ANSMINDEX,
      pagination: initialPagination,
      filter,
      searchString,
    });

    const formElements = {
      ...getCompatibleFormFromQueryFilter(filter),
      searchString,
    };

    const form = {
      ...cloneDeep(initialForm),
      ...formElements,
    };

    return {
      form,
      ansm,
      pagination: {
        ...initialPagination,
        total,
      },
      isFilterModalOpened: false,
      SCALE_FILTER,
      THEME_FILTER,
      PROGRAM_OPTIONS,
      isMobile: false,
    };
  },

  computed: {
    ansmNumberString() {
      const { total } = this.pagination;
      const isPlural = total > 1;

      return `${total} ressource${isPlural ? 's' : ''} disponible${
        isPlural ? 's' : ''
      } pour vous`;
    },
  },

  watch: {
    form: {
      handler() {
        this.filterAnsm();
      },
      deep: true,
    },
  },

  mounted() {
    this.updateResponsiveState();
    window.addEventListener('resize', this.updateResponsiveState);
  },

  destroyed() {
    window.removeEventListener('resize', this.updateResponsiveState);
  },

  methods: {
    async updatePage() {
      const filter = this.generateFilter();

      const { ansm, total } = await searchAnsmItem(this.$search, {
        index: ANSMINDEX,
        pagination: this.pagination,
        filter,
        searchString: this.form.searchString,
      });

      this.ansm = ansm;
      this.setPagination({ total });
    },
    async filterAnsm() {
      const filter = this.generateFilter();
      const queryFilter = qs.stringify(filter);

      await this.$router.replace({
        path: this.$route.path,
        query: {
          ...this.$route.query,
          filter: queryFilter,
          search: this.form.searchString,
        },
      });

      const { ansm, total } = await searchAnsmItem(this.$search, {
        index: ANSMINDEX,
        pagination: this.pagination,
        filter,
        searchString: this.form.searchString,
      });

      this.ansm = ansm;
      this.setPagination({ total, current: 1 });
    },

    generateFilter() {
      return [
        this.generateScalesFilter(),
        this.generateThemesFilter(),
        this.generateProgramFilter(),
        this.generateTypesFilter(),
        this.generateStatusFilter(),
      ].filter(({ length }) => length > 0);
    },
    generateScalesFilter() {
      const filter = this.form.scales.map((scale) => `target = "${scale}"`);

      return filter.length ? filter : '';
    },
    generateThemesFilter() {
      return this.form.themes.map(
        (theme) => `themes = "${theme}" OR competence = "${theme}"`,
      );
    },
    generateProgramFilter() {
      return this.form.program && this.form.program !== 'Tous les programmes'
        ? `program = "${this.form.program}"`
        : '';
    },
    generateStatusFilter() {
      return this.form.isAvailable ? `stage = "Disponible"` : '';
    },
    generateTypesFilter() {
      const filter = [];

      if (this.form.isService) {
        filter.push('type = "Service numérique"');
      }

      if (this.form.isGuide) {
        filter.push('type = "Kit et Guide"');
      }

      return filter.length ? filter : '';
    },

    oggleScale(value) {
      if (this.form.scales.includes(value)) {
        this.form.scales = this.form.scales.filter((scale) => scale !== value);
      } else {
        this.form.scales.push(value);
      }
    },
    toggleTheme(value) {
      if (this.form.themes.includes(value)) {
        this.form.themes = this.form.themes.filter((theme) => theme !== value);
      } else {
        this.form.themes.push(value);
      }
    },

    truncateString(str, charNumber = 100) {
      if (str.length > charNumber) {
        return `${str.substring(0, charNumber)}...`.replace(/<[^>]+>/gi, '');
      }
      return str;
    },

    getTagCSSClasses(pop) {
      if (pop < 500) {
        return 'anct-bg-bourgeon anct-text-bourgeon';
      }
      if (pop < 1000) {
        return 'anct-bg-emeraude anct-text-emeraude';
      }
      if (pop < 3500) {
        return 'anct-bg-menthe anct-text-menthe';
      }
      if (pop < 5000) {
        return 'anct-bg-archipel anct-text-archipel';
      }
      if (pop < 10000) {
        return 'anct-bg-ecume anct-text-ecume';
      }
      return 'anct-bg-cumulus anct-text-cumulus';
    },

    getPopulationNumber(pop) {
      if (pop < 500) {
        return '< 500 hab';
      }
      if (pop < 1000) {
        return '< 1 000 hab';
      }
      if (pop < 3500) {
        return '< 3 500 hab';
      }
      if (pop < 5000) {
        return '< 5 000 hab';
      }
      if (pop < 10000) {
        return '< 10 000 hab';
      }
      return '> 10 000 hab';
    },

    openFilterModal() {
      this.isFilterModalOpened = true;
    },
    closeFilterModal() {
      this.isFilterModalOpened = false;
    },

    updateResponsiveState() {
      this.isMobile = window.innerWidth < this.$config.mobileBreakpoint;
    },
  },
};
</script>

<style scoped>
#search-service {
  margin-bottom: 32px;
}
</style>
